Bug 21495 - Changes made to metadata on smbfs volumes not immediately reflected
Changes made to metadata on smbfs volumes not immediately reflected
Product: Red Hat Linux
Classification: Retired
Component: kernel (Show other bugs)
i386 Linux
medium Severity medium
: ---
: ---
Assigned To: Michael K. Johnson
Dale Lovelace
Depends On:
  Show dependency treegraph
Reported: 2000-11-29 14:01 EST by Rupa Schomaker
Modified: 2007-04-18 12:30 EDT (History)
1 user (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Last Closed: 2002-12-14 23:04:04 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---

Attachments (Terms of Use)

  None (edit)
Description Rupa Schomaker 2000-11-29 14:01:46 EST
If I change metadata (filename, create directory, etc) on a mounted smbfs 
file system, I don't see the metadata change until I wait for an extended 
period of time or I umount/remote the share.

Client: Redhat 6.2 -- 2.2.16 SRPM + Andre's IDE patches (so that I can use 
my promise card).  I have RAID1 compiled into the kernel (I boot off of an 

Server: NT 2000 Pro.

Linux shakti 2.2.16 #24 Thu Nov 23 14:07:16 PST 2000 i686 unknown

[rupa@shakti rupa]$ df -k ~/cdr
Filesystem           1k-blocks      Used Available Use% Mounted on
//rupa/share           9749760   7635456   2114304  78% /home/rupa/cdr
[rupa@shakti rupa]$ ls ~/cdr
Office/  classes/  gunman/  new/  vcd/  vcd_tmp/
[rupa@shakti rupa]$ mkdir ~/cdr/foo
[rupa@shakti rupa]$ ls ~/cdr
Office/  classes/  gunman/  new/  vcd/  vcd_tmp/
[rupa@shakti rupa]$ ls -ld ~/cdr
drwxrwxr-x    1 rupa     rupa          512 Dec 10  1999 /home/rupa/cdr/
[rupa@shakti rupa]$ smbumount ~/cdr
[rupa@shakti rupa]$ mountrupa
[rupa@shakti rupa]$ ls ~/cdr
Office/  classes/  foo/  gunman/  new/  vcd/  vcd_tmp/
[rupa@shakti rupa]$ rmdir ~/cdr/foo
[rupa@shakti rupa]$ ls ~/cdr
ls: /home/rupa/cdr/foo: No such file or directory
Office/  classes/  gunman/  new/  vcd/  vcd_tmp/
Comment 1 Bill Nottingham 2001-01-18 19:05:50 EST
What happens if you run 'sync'? It probably won't help, but it might.
Comment 2 Bill Nottingham 2001-01-18 19:06:28 EST
(Assigning to kernel; that's where the guts of the smbfs support is.)
Comment 3 Rupa Schomaker 2001-01-19 00:22:01 EST
running sync seems to do nothing.  Same behavior as described above.
Comment 4 Urban Widmark 2001-01-28 17:44:40 EST
This is a bug in the dircache code in 2.2.16 (and I was the one that introduced
it, sorry about that).

It looks at the mtime of the parent directory and assumes that it will be
updated when the contents change, which many servers doesn't (and not on all
changes). 2.2.18/2.4.0 should have this fixed.

Note that in 2.4.0 the smbfs dircache code is completely broken on highmem
machines. Experimental patch at:

Comment 5 Rupa Schomaker 2001-01-29 11:23:29 EST
Is there a "simple" patch I can apply against redhat's 6.2 kernel sources to 
get this behavior fixed?  If not, I guess I just have to wait 'till redhat 
updates the kernel in their dist.


Note You need to log in before you can comment on or make changes to this bug.